// AnalogVideo capture by ATmega88pa-au
//
// Autor M.Klokov http://roboforum.ru/forum88/topic6822.html
//
// http://mkpochtoi.ru/


#include <avr/io.h>
#include <avr/pgmspace.h>
#include <avr/interrupt.h>
#include "uart.h"


#define LED_ON()	{ PORTB|=0x04; }
#define LED_OFF()	{ PORTB&=0xFB; }


unsigned char buffer[640];
unsigned char * lbuf = buffer;
volatile unsigned char flag;

unsigned int i;

unsigned char start_line;

void main(void)
{

unsigned char c;


    DDRB = 0x04;		// LED output
	
	ACSR   = 0x1B;		// Comparator Interrupt on rising edge enabled
	DIDR1  = 0x03;		// Digital inputs disable

	ADMUX  = 0xE7;	 	// ADC channel 7, left ajusted, ref=1.1V
	ADCSRA = 0x82;		// ADC enable

	UCSR0A=0x00;
	UCSR0B=0x18;
	UBRR0H=0;	
	UBRR0L=0;			// 1250kbaud @ 20MHz

	TCCR0B = 2;

	while(1)
	{
		if(uart_received()) 						// ????? ????
		{
			c=uart_getbyte();
			if (c>='0'&&c<='7')						// ?? ?? ???? ? 0  7, ?...
			{
			    start_line = (c-'0')<<5;			// ??? ? ??? 0, 32, 64, 96 ? ?..,
			    									// 

				uart_putbyte('*');					// ??? ?????

				LED_ON();

				flag=0;								// ??????? ??????? ???
				ACSR|=0x10;							// ??????? ?? ?????
				lbuf = buffer;                      // ?? ???? ???????? ??
				
				sei();								// ????? ????????
				while(flag!=2);						// ?, ?? ???????? ? ??? ??? ??
				cli();								// ????? ????????
				flag=0;								

				LED_OFF();

					for(i=0;i<640;i++)				// ??, ? ?? ???????? ?? ? ?????
					{
						uart_putchar(buffer[i]);
					}
				uart_putbyte(13);
				uart_putbyte(10);
			}
		}
	}
}

SIGNAL(SIG_COMPARATOR)
{
unsigned int c;
unsigned char i;
static unsigned char sync=0;
static unsigned char line=0;
                                                                  
	if(sync) {sync--; return;}				// ??????? ????? ??? ????????
	if(line)								// ?? ??? ????? ??
	{

// ??????? ????? ??

		asm("nop");	asm("nop");	asm("nop");	asm("nop");	asm("nop");	asm("nop");	
		asm("nop");	asm("nop");	asm("nop");	asm("nop");	asm("nop");	asm("nop");	asm("nop");
		asm("nop");	asm("nop");	asm("nop");	asm("nop");	asm("nop");	asm("nop");	
		asm("nop");	asm("nop");	asm("nop");	asm("nop");	asm("nop");	asm("nop");	asm("nop");
		asm("nop");	asm("nop");	asm("nop");	asm("nop");	asm("nop");	asm("nop");	
		asm("nop");	asm("nop");	asm("nop");	asm("nop");	asm("nop");	asm("nop");	asm("nop");

// ??? ????? ? ?? ?????, ???? ?????? ??? ? ??? ?????

		if((line&0x03)==2)
		{
			asm("nop");	asm("nop");	asm("nop");	asm("nop");	asm("nop");	asm("nop");	
			asm("nop");	asm("nop");	asm("nop");	asm("nop");	asm("nop");	asm("nop");	asm("nop");
		}
		if((line&0x03)==3)
		{
			asm("nop");	asm("nop");	asm("nop");	asm("nop");	asm("nop");	asm("nop");	
			asm("nop");	asm("nop");	asm("nop");	asm("nop");	asm("nop");	asm("nop");	asm("nop");	
			asm("nop");	asm("nop");	asm("nop");	asm("nop");	asm("nop");	asm("nop");	
			asm("nop");	asm("nop");	asm("nop");	asm("nop");	asm("nop");	asm("nop");	asm("nop");
		}
		if((line&0x03)==1)
		{
			asm("nop");	asm("nop");	asm("nop");	asm("nop");	asm("nop");	asm("nop");	
			asm("nop");	asm("nop");	asm("nop");	asm("nop");	asm("nop");	asm("nop");	asm("nop");
			asm("nop");	asm("nop");	asm("nop");	asm("nop");	asm("nop");	asm("nop");	
			asm("nop");	asm("nop");	asm("nop");	asm("nop");	asm("nop");	asm("nop");	asm("nop");
			asm("nop");	asm("nop");	asm("nop");	asm("nop");	asm("nop");	asm("nop");	
			asm("nop");	asm("nop");	asm("nop");	asm("nop");	asm("nop");	asm("nop");	asm("nop");
		}
			
// ??? ? ?? ? ????

			ADCSRA=0xE2;								// Enable ADC and start new conversion
			for(c=0;c<=17;c++)
			{
				while ((ADCSRA&0x10)==0);				// Wait for conversion complete 
				ADCSRA=0xF2;							// Clear interrupt flag

// ?? ?????? ?????? ? ????? ????, ? ???? ? ?????

				if (((252-line)&0xE0)==start_line) *lbuf++=(ADCH);
			}
			while ((ADCSRA&0x10)==0);					// Wait for conversion complete 
			ADCSRA=0xD2;								// Clear interrupt flag and free running mode
			if (((252-line)&0xE0)==start_line) *lbuf++=(ADCH);
			while ((ADCSRA&0x10)==0);					// Wait for conversion complete 
			ADCSRA=0x92;								// Clear interrupt flag and stop
			if (((252-line)&0xE0)==start_line) *lbuf++=(ADCH);
		
		line--;				// ??? ???? ?????? ????
		if(line==0) flag++;	// ??? ??? ????? ????? - ???? ??????? ??? ???

	}
	else
	{

// ?? ????? ????? ??????, ? ??? ???? ?????????

		ADCSRA=0xE2;				// Enable ADC and start new conversion
		while ((ADCSRA&0x10)==0);	// Wait for conversion complete 
		ADCSRA=0xF2;				// Clear interrupt flag
		while ((ADCSRA&0x10)==0);	// Wait for conversion complete 
		ADCSRA=0xF2;				// Clear interrupt flag
		while ((ADCSRA&0x10)==0);	// Wait for conversion complete 
		ADCSRA=0xF2;				// Clear interrupt flag
		while ((ADCSRA&0x10)==0);	// Wait for conversion complete 
		ADCSRA=0xF2;				// Clear interrupt flag
		while ((ADCSRA&0x10)==0);	// Wait for conversion complete 
		ADCSRA=0xF2;				// Clear interrupt flag
		while ((ADCSRA&0x10)==0);	// Wait for conversion complete 
		ADCSRA=0xF2;				// Clear interrupt flag
		while ((ADCSRA&0x10)==0);	// Wait for conversion complete 
		ADCSRA=0xF2;				// Clear interrupt flag
		while ((ADCSRA&0x10)==0);	// Wait for conversion complete 
		ADCSRA=0xF2;				// Clear interrupt flag
		while ((ADCSRA&0x10)==0);	// Wait for conversion complete 
		ADCSRA=0xD2;				// Clear interrupt flag and free running mode
		while ((ADCSRA&0x10)==0);	// Wait for conversion complete 
		ADCSRA=0x92;				// Clear interrupt flag
		if (ADCH<10)
		{

// ???? ????????? ? - ???? 29 ??????????, ? ?? 252 ????? ?????.
// ????? ?? ???? ?? ??.

			line=252; sync=29; lbuf=buffer;
		}
	}
}

